#-----------------------------------------
# loading data and required packages
rm(list = ls())
library(readxl)
library(Matrix)
library(ggvis)
library(tidyr)
setwd('/Users/mahradvaghefi/Desktop/empirical_analysis_2_11_2019/forecasting')
Varnames <- read_excel('StockWatson.xlsx',sheet = 3)
load('Result.RData')
#-----------------------------------------
# Spliting data into half. (Befor and After the Breakpoint) 
Track = Track1$GDP251
colnames(Track) = colnames(Z)
Predic_Time = seq(ISOdate(1990,8,1), ISOdate(2008,11,1), by = "quarter")
Predic_Time = trunc(Predic_Time, units = "days")
Predic_Time = as.POSIXct(Predic_Time)
row.names(Track) = as.character(Predic_Time)
Breakpoint = which(row.names(Track)== "2000-02-01")
BPredic_Time =  Predic_Time[1:(Breakpoint-1)]
APredic_Time =  Predic_Time[Breakpoint:nrow(Track)]
BTrack = Track[1:(Breakpoint-1),] # Before Breakpoint
ATrack = Track[Breakpoint:nrow(Track),] # After Breakpoint
BSelVAR = BTrack[,apply(BTrack,2,sum)>0]
ASelVAR = ATrack[,apply(ATrack,2,sum)>0]

#--------------------------------------------
# Sorting Variables based on their selection frequency
BFreq = apply(BSelVAR,2,mean)
AFreq = apply(ASelVAR,2,mean)
BFreq = sort(BFreq,decreasing = TRUE)
AFreq = sort(AFreq,decreasing = TRUE)
BSelVAR = BSelVAR[,names(BFreq)]
ASelVAR = ASelVAR[,names(AFreq)]

#----------------------------------------------
# Selecting Top n Variables based on Frequency
n = 5
BTOP = BSelVAR[,1:n]
ATOP = ASelVAR[,1:n]
for (i in 1:n) {
  for (j in 1:nrow(Varnames)){
    if (colnames(BTOP)[i] == Varnames[j,1]) {
      colnames(BTOP)[i] = Varnames[j,2]
    }
    if (colnames(ATOP)[i] == Varnames[j,1]) {
      colnames(ATOP)[i] = Varnames[j,2]
    }
  }
}
#----------------------------------------------
# Plot frequcey of Top n Variables
BTOP = data.frame(Time = BPredic_Time,BTOP)
ATOP = data.frame(Time = APredic_Time,ATOP)
PlotBdata = gather(BTOP, Variables, Frequency, -Time) 
PlotAdata = gather(ATOP, Variables, Frequency, -Time)
PlotBdata %>% ggvis(x = ~Time, y = ~Frequency, stroke = ~Variables)%>%layer_lines()
PlotAdata %>% ggvis(x = ~Time, y = ~Frequency, stroke = ~Variables)%>%layer_lines()
